Loading...
Searching...
No Matches
CCacheHash< CExponent > Class Template Reference

`#include <ncSACache.h>`

## Data Structures

struct | CCacheItem
union | CCacheItem.a
union | CCacheItem.b

## Public Types

enum | EHistoryType { MULT_LOOKUP = 0 , MULT_STORE = 1 }

## Public Member Functions

| CCacheHash (ring r)
ring | GetBasering () const
int | NVars () const
virtual | ~CCacheHash ()
int | LookupEE (CExponent a, CExponent b, CCacheItem *&pItems)
bool | StoreEE (CExponent a, CExponent b, poly pProduct)
virtual void | History (const EHistoryType, const CExponent, const CExponent, const poly=NULL)

## Private Member Functions

| CCacheHash (const CCacheHash &)
CCacheHash & | operator= (const CCacheHash &)

## Private Attributes

ring | m_basering
int | m_NVars

## Detailed Description

template<typename CExponent>
class CCacheHash< CExponent >

Definition at line 16 of file ncSACache.h.

## Data Structure Documentation

## CCacheHash::CCacheItem

struct CCacheHash::CCacheItem

template<typename CExponent>
struct CCacheHash< CExponent >::CCacheItem

Definition at line 36 of file ncSACache.h.

Data Fields
union CCacheItem.a | a |
union CCacheItem.b | b |
int | iPairType |
long | lHits |
poly | pProduct |

## CCacheHash::CCacheItem.a

union CCacheHash::CCacheItem.a

template<typename CExponent>
union CCacheHash< CExponent >::CCacheItem.a

Definition at line 38 of file ncSACache.h.

Data Fields
CExponent | aExponent |
poly | aMonom |

## CCacheHash::CCacheItem.b

union CCacheHash::CCacheItem.b

template<typename CExponent>
union CCacheHash< CExponent >::CCacheItem.b

Definition at line 43 of file ncSACache.h.

Data Fields
CExponent | bExponent |
poly | bMonom |

## Member Enumeration Documentation

## EHistoryType

template<typename CExponent>

enum CCacheHash::EHistoryType

Enumerator
MULT_LOOKUP |
MULT_STORE |

Definition at line 31 of file ncSACache.h.

{
MULT_LOOKUP = 0,
MULT_STORE = 1
};
CCacheHash::MULT_STORE
@ MULT_STORE
Definition ncSACache.h:33
CCacheHash::MULT_LOOKUP
@ MULT_LOOKUP
Definition ncSACache.h:32

## Constructor & Destructor Documentation

## CCacheHash() [1/2]

template<typename CExponent>

CCacheHash< CExponent >::CCacheHash | ( | ring | r | ) |

inline

Definition at line 23 of file ncSACache.h.

: m_basering(r), m_NVars(r->N){};
CCacheHash
Definition ncSACache.h:17
CCacheHash::m_basering
ring m_basering
Definition ncSACache.h:19
CCacheHash::m_NVars
int m_NVars
Definition ncSACache.h:20

## ~CCacheHash()

template<typename CExponent>

virtual CCacheHash< CExponent >::~CCacheHash | ( |  | ) |

inline virtual

Definition at line 28 of file ncSACache.h.

{};

## CCacheHash() [2/2]

template<typename CExponent>

CCacheHash< CExponent >::CCacheHash | ( | const CCacheHash< CExponent > & |  | ) |

private

## Member Function Documentation

## GetBasering()

template<typename CExponent>

ring CCacheHash< CExponent >::GetBasering | ( |  | ) | const

inline

Definition at line 25 of file ncSACache.h.

{ return m_basering; };

## History()

template<typename CExponent>

virtual void CCacheHash< CExponent >::History | ( | const EHistoryType | ,
|  | const CExponent | ,
|  | const CExponent | ,
|  | const poly | = NULL )

inline virtual

Definition at line 87 of file ncSACache.h.

{
PrintS("CCacheHash::History(a, b, [p])!\n");
}
PrintS
void PrintS(const char *s)
Definition reporter.cc:288

## LookupEE()

template<typename CExponent>

int CCacheHash< CExponent >::LookupEE | ( | CExponent | a,
|  | CExponent | b,
|  | CCacheItem *& | pItems )

inline

Definition at line 56 of file ncSACache.h.

{
/*
PrintS("//////////////////////////////////////////////////////////////////////////////////////////////");
PrintLn();
PrintS("CCacheHash::LookupEE(a, b, *results)!");
PrintLn();
*/
History(MULT_LOOKUP, a, b);
pItems = NULL;
return -1;
}
CCacheHash::History
virtual void History(const EHistoryType, const CExponent, const CExponent, const poly=NULL)
Definition ncSACache.h:87

## NVars()

template<typename CExponent>

int CCacheHash< CExponent >::NVars | ( |  | ) | const

inline

Definition at line 26 of file ncSACache.h.

{ return m_NVars; }

## operator=()

template<typename CExponent>

CCacheHash & CCacheHash< CExponent >::operator= | ( | const CCacheHash< CExponent > & |  | ) |

private

## StoreEE()

template<typename CExponent>

bool CCacheHash< CExponent >::StoreEE | ( | CExponent | a,
|  | CExponent | b,
|  | poly | pProduct )

inline

Definition at line 70 of file ncSACache.h.

{
/*
PrintS("CCacheHash::StoreEE(a, b, Product)!");
PrintLn();
*/
History(MULT_STORE, a, b, pProduct);
/*
PrintS("\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\");
PrintLn();
*/
return false; // the pair was not stored!
};

## Field Documentation

## m_basering

template<typename CExponent>

ring CCacheHash< CExponent >::m_basering

private

Definition at line 19 of file ncSACache.h.

## m_NVars

template<typename CExponent>

int CCacheHash< CExponent >::m_NVars

private

Definition at line 20 of file ncSACache.h.

The documentation for this class was generated from the following file:

- libpolys/polys/nc/ncSACache.h